#include <cstdlib>
#include <iostream>
#include <stdio.h>
#include <time.h>

using namespace std;

#include "Zufall.h"
#include "DNA.h"


#include "Individuum.h"
#include "Umwelt.h"

#define ANZAHL_DNA 100
#define ANZAHL_BESTE 10

int main(int argc, char *argv[])
{
    //Teil 1:
    int anzahl_mutationen=10;

    DNA<long int> dna[ANZAHL_DNA];
    Individuum ind[ANZAHL_DNA];

    double fit,fit_alt;
    double besten_fitness[ANZAHL_BESTE];
    int besten_index[ANZAHL_BESTE];
    DNA<long int> besten_dna[ANZAHL_BESTE];

    Umwelt umwelt;

    //Teil 2:
    for(int i=0;i<ANZAHL_DNA;i++)
        dna[i].init(2);
    for(int i=0;i<ANZAHL_BESTE;i++)
        besten_dna[i].init(2);


    for(int i=0;i<100;i++)
    {
        dna[i].x[0] = 10000*(i%10);
        dna[i].x[1] = 10000*(i/10);
    }

    //Teil 3:
    ind[0].regeneriereIndividuum(&dna[0]);
    fit = umwelt.testeFitness(&ind[0]);    
    for(int p=0;p<ANZAHL_BESTE;p++)
    {
        besten_fitness[p]=fit;
        besten_index[p]=0;
    }

    //Teil 4:
    for(int generation=0;generation<100;generation++)
    {
        //Teil 4.1
        for(int i=0;i<ANZAHL_DNA;i++)
        {
            ind[i].regeneriereIndividuum(&dna[i]);
            fit = umwelt.testeFitness(&ind[i]);    
            if(fit>=besten_fitness[0])
            {
                for(int p=ANZAHL_BESTE-1;p>=1;p--)
                {
                    besten_fitness[p]=besten_fitness[p-1];
                    besten_index[p]=besten_index[p-1];
                }
                besten_fitness[0]=fit;
                besten_index[0]=i;
            }
        }

        //Teil 4.2
        if(generation%1==0)
        {
            cout<<"Gener. Nr."<<generation;
            printf(" Groesste Fitn.: %8.8f",besten_fitness[0]);
//            cout<<" Groesste Fitness:"<<besten_fitness[0];
//            cout<<" bei Individuum x="<<ind[besten_index[0]].x<<" y="<<ind[besten_index[0]].y<<endl;
            printf(" bei Indiv. x=%8.8f y=%8.8f\n",ind[besten_index[0]].x,ind[besten_index[0]].y);
        }

        //Teil 4.3
        for(int k=0;k<ANZAHL_BESTE;k++)
            besten_dna[k].kopieren(&dna[besten_index[k]]);

        for(int k=0;k<ANZAHL_BESTE;k++)
            dna[k].kopieren(&besten_dna[k]);
        for(int k=ANZAHL_BESTE;k<ANZAHL_DNA;k++)
            dna[k].rekombinieren(&dna[rand()%ANZAHL_BESTE],&dna[rand()%ANZAHL_BESTE]);
        for(int k=ANZAHL_BESTE;k<ANZAHL_DNA;k++)
            for(int p=0;p<anzahl_mutationen;p++)
                dna[k].mutation();


        //Teil 4.4
        if( fit_alt+0.001>fit  )
        {
            anzahl_mutationen*=2;
            anzahl_mutationen%=32;
        }
        else
        {
            anzahl_mutationen/=2;
            if(anzahl_mutationen<2)
                anzahl_mutationen=2;
        }

        fit_alt = fit;

    }

    system("PAUSE");
    return EXIT_SUCCESS;
}
