template <typename meinDATENTYP>
class DNA
{
    public:
        int anzahl;
        int anzahl_byte;
        int anzahl_bits;
        meinDATENTYP* x;
        unsigned char* b;

        DNA()
        {
        }

        DNA(int anzahl)
        {
            init(anzahl);
        }

        void init(int anzahl)
        {
            this->anzahl = anzahl;
            x = new meinDATENTYP[anzahl+1];
            b = (unsigned char*)&x[0];
            anzahl_byte = (int)( (unsigned char*)&x[anzahl] - (unsigned char*)&x[0] );
            anzahl_bits = anzahl_byte*8;
        }

        void zufall()
        {
            for(int i=0;i<anzahl_byte;i++)
                b[i]=Zufall::zahl(0,255);
        }

        void setze(int nummer, meinDATENTYP wert)
        {
            x[nummer] = wert;
        }

        void mutation()
        {
            int bit_nummer = Zufall::zahl(0,7);
            int byte_nummer = Zufall::zahl(0,anzahl_byte-1);
            if( (b[byte_nummer] & (1<<bit_nummer))>0 )
                 b[byte_nummer] &= 255 - (1<<bit_nummer);
            else
                 b[byte_nummer] |= (1<<bit_nummer);
        }

        void kopieren(DNA<meinDATENTYP>* dna)
        {
            for(int i=0;i<anzahl_byte;i++)
                 b[i] = dna->b[i];
        }

        void rekombinieren(DNA<meinDATENTYP>* dna1, DNA<meinDATENTYP>* dna2)
        {
            for(int i=0;i<anzahl_byte;i++)
            {
                for(int k=0;k<8;k++)
                {
                    if(Zufall::zahl(0,1)==0)
                    {
                        if(  (dna1->b[i] & (1<<k)) > 0 )
                            b[i] |= (1<<k);
                        else
                            b[i] &= 255 - (1<<k);
                    }
                    else
                    {
                        if(  (dna2->b[i] & (1<<k)) > 0 )
                            b[i] |= (1<<k);
                        else
                            b[i] &= 255 - (1<<k);
                    }
                }
            }
        }

        void zeigen()
        {
            cout<<endl;
            for(int i=0;i<anzahl;i++)
                cout<<i<<".: "<<x[i]<<endl;
        }

        void zeigenBinaer()
        {
            int aufteilung = anzahl_byte/anzahl;
            cout<<endl;
            for(int i=0;i<anzahl_byte;i++)
            {
                cout<<endl;
                if(i>0 && i%aufteilung==0)
                    cout<<endl;
                for(int k=0;k<8;k++)
                {
                        if(  (b[i] & (1<<k)) > 0 )
                            cout<<1;
                        else
                            cout<<0;
                }
            }
            cout<<endl;
        }
}; 
